package org.bitbucket.bradleysmithllc.etlagent.informatica.provider;

import org.bitbucket.bradleysmithllc.etlagent.informatica.dto.RemoteFile;
import org.bitbucket.bradleysmithllc.webserviceshubclient.parameter.ParameterFile;

import java.util.List;
import java.util.Map;

public interface InformaticaExecutionClient
{
	InformaticaExecutionResult executeWorkflow(
			String workFlow,
			String folder,
			ParameterFile parmFile
	) throws Exception;

	InformaticaExecutionResult executeWorkflow(
			String workFlow,
			String folder,
			ParameterFile parmFile,
			Map<RemoteFile.fileType, List<RemoteFile>> remoteFiles
	) throws Exception;

	InformaticaExecutionResult executeWorkflow(
			String workFlow,
			String runInstanceName,
			String folder,
			ParameterFile parmFile
	) throws Exception;

	InformaticaExecutionResult executeWorkflow(
			String workFlow,
			String runInstanceName,
			String folder,
			ParameterFile parmFile,
			Map<RemoteFile.fileType, List<RemoteFile>> remoteFiles
	) throws Exception;

	InformaticaExecutionResult executeWorkflowTask(
			String workFlow,
			String task,
			String folder,
			ParameterFile parmFile
	) throws Exception;

	InformaticaExecutionResult executeWorkflowTask(
			String workFlow,
			String task,
			String folder,
			ParameterFile parmFile,
			Map<RemoteFile.fileType, List<RemoteFile>> remoteFiles
	) throws Exception;

	InformaticaExecutionResult executeWorkflowTask(
			String workFlow,
			String runInstanceName,
			String task,
			String folder,
			ParameterFile parmFile
	) throws Exception;

	InformaticaExecutionResult executeWorkflowTask(
			String workFlow,
			String runInstanceName,
			String task,
			String folder,
			ParameterFile parmFile,
			Map<RemoteFile.fileType, List<RemoteFile>> remoteFiles
	) throws Exception;
}